MCP Tools Reference: chatmcp.googleapis.com

Tool: mark_as_unread

Marks a Google Chat conversation or thread as unread for the calling user.

Preconditions:

  • Exactly one of conversationId (format: spaces/{space}) or threadId (format: spaces/{space}/threads/{thread}) must be provided.
  • lastReadTime is required: an ISO 8601 timestamp at which to mark the conversation or thread as unread.

Behavior:

  • If lastReadTime is before the calling user's current read state timestamp, the read state is updated to this timestamp (marking subsequent messages unread).
  • If lastReadTime is at or after the current read state, the request is a no-op and returns successfully without modifying the read state.
  • Unlike mark_as_read (which supports bulk operations on lists of IDs), mark_as_unread operates on a single conversation or thread and returns an empty response upon success.

The following code sample shows how to use curl to call the mark_as_unread MCP tool.

Curl Request
curl --location 'https://chatmcp.googleapis.com/mcp/v1' \
--header 'Authorization: Bearer YOUR_ACCESS_TOKEN' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "mark_as_unread",
    "arguments": {
      // provide these details according to the tool MCP specification
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'

Input Schema

MarkAsUnreadRequest

JSON representation
{
  "lastReadTime": string,

  "conversationId": string,
  "threadId": string
}
Fields
lastReadTime

string (Timestamp format)

Required. The timestamp at which to mark the conversation or thread as unread. If the timestamp is before the calling user's current read state timestamp, the read state is updated to this timestamp. Otherwise, the request is a no-op and returns a successful response without modifying the read state.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field id. Exactly one of conversation_id or thread_id is required. id can be only one of the following:
conversationId

string

The conversation ID to mark as unread. Format: spaces/{space}

threadId

string

The thread ID to mark as unread. Format: spaces/{space}/threads/{thread}

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

Output Schema

Tool Annotations

Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.

Along with the title string, the following boolean hints are defined as follows:

  • readOnlyHint: If true, the tool doesn't modify its environment. Default: false.
  • destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.
  • idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.
  • openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.

Destructive Hint: ✅ | Idempotent Hint: ✅ | Read Only Hint: ❌ | Open World Hint: ❌

Authorization Scopes

Requires one of the following OAuth scopes:

  • https://www.googleapis.com/auth/chat.users.readstate